{{ ansible_managed | comment }}
extensions:
{% if _otelcol_metrics or _otelcol_logs or otelcol_custom_pipeline is defined%}
  oauth2client/client:  
    client_id: {{ otelcol_client_id }}
    client_secret: {{ otelcol_client_secret }}
    token_url: {{ otelcol_token_url }}
    tls:
      insecure: true
{% endif %}

receivers:
{% if otelcol_custom_receiver is defined %}
{{ otelcol_custom_receiver | indent(2, true)}}
{% endif %}
{% if _otelcol_host_telemetry %}
{%   if _otelcol_host_metrics %}
  prometheus/host:
    config:
      scrape_configs:
        - job_name: otel_exporter
          scrape_interval: 10s
          static_configs:
            - targets: [localhost:8888]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}

{%     if prometheus_node_exporter %}
        - job_name: node_exporter
          scrape_interval: 5s
          static_configs:
            - targets: [{{ prometheus_node_exporter_web_listen_address }}]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}
{%     endif %}
{%     if prometheus_windows_exporter %}
        - job_name: windows_exporter
          scrape_interval: 5s
          static_configs:
            - targets: [{{ prometheus_windows_exporter_web_listen_address }}]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}
{%     endif %}
{%     if prometheus_postgres_exporter %}
        - job_name: postgres_exporter
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /metrics
          scheme: http
          static_configs:
            - targets: [{{ prometheus_postgres_exporter_web_listen_address }}]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}

{%     endif %}
{%     if prometheus_mysqld_exporter %}
        - job_name: mysqld_exporter
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /metrics
          scheme: http
          static_configs:
            - targets: [{{ prometheus_mysqld_exporter_web_listen_address }}]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}

{%     endif %}
{%     if prometheus_maas_exporter %}
        - job_name: maas-region-rack
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /metrics
          scheme: http
          static_configs:
            - targets: {{ maas_region_rack_exporter_web_listen_address }}
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}
        - job_name: maas-metrics
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /MAAS/metrics
          scheme: http
          static_configs:
            - targets: {{ maas_metrics_exporter_web_listen_address }}
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}
{%     endif %}
{%     if prometheus_nginxlog_exporter %}
        - job_name: nginxlog_exporter
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /metrics
          scheme: http
          static_configs:
            - targets: [{{ prometheus_nginxlog_exporter_web_listen_address }}]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}

{%     endif %}
{%     if prometheus_nginx_exporter %}
        - job_name: nginx_exporter
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /metrics
          scheme: http
          static_configs:
            - targets: [{{ prometheus_nginx_exporter_web_listen_address }}]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}

{%     endif %}
{%     if prometheus_uwsgi_exporter %}
        - job_name: uwsgi_exporter
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /metrics
          scheme: http
          static_configs:
            - targets: [localhost:9117]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}

{%     endif %}
{%     if prometheus_postfix_exporter %}
        - job_name: postfix_exporter
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /metrics
          scheme: http
          static_configs:
            - targets: [localhost:9154]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}

{%     endif %}
{%     if prometheus_memcached_exporter %}
        - job_name: memcached_exporter
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /metrics
          scheme: http
          static_configs:
            - targets: [localhost:9150]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}

{%     endif %}
{%     if prometheus_redis_exporter %}
        - job_name: redis_exporter
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /metrics
          scheme: http
          static_configs:
            - targets: [localhost:9121]
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}

{%     endif %}
{%   endif %}
{%   if _otelcol_host_logs %}
{%     if otelcol_receiver_journald %}
  journald/host:
    directory: {{ otelcol_receiver_journald_directory }}
    units: {{ otelcol_receiver_journald_units }}
    priority: {{ otelcol_receiver_journald_prio }}
{%     elif otelcol_receiver_windows_events %}
{%       for windows_eventlog in otelcol_receiver_windows_eventlogs %}
  windowseventlog/{{ windows_eventlog }}:
    channel: {{ windows_eventlog }}
{%       endfor %}
{%     endif %}
{%   endif %}
{% endif %}
{% if _otelcol_external_telemetry %}
{%   if _otelcol_external_metrics %}
  prometheus/external:
    config:
      scrape_configs:
{%     if prometheus_node_exporter_external %}
        - job_name: node_exporter
          scrape_interval: 10s
          file_sd_configs:
            - files:
                - '{{ _otelcol_config_targets_path }}/node_exporter_*.yml'

{%     endif %}
{%     if prometheus_blackbox_exporter %}
        - job_name: blackbox_exporter
          metrics_path: /probe
          scrape_interval: 10s
          scrape_timeout: 5s
          file_sd_configs:
            - files:
                - '{{ _otelcol_config_targets_path }}/blackbox_exporter_*.yml'
          relabel_configs:
            - source_labels: [__address__]
              target_label: __param_target
            - source_labels: [__param_target]
              target_label: instance
            - source_labels: [__module]
              target_label: __param_module
            - target_label: __address__
              replacement: localhost:9115

{%     endif %}
{%     if prometheus_helmet_exporter %}
        - job_name: 'helmet_exporter'
          scrape_interval: 10s
          file_sd_configs:
            - files:
                - '{{ _otelcol_config_targets_path }}/helmet_exporter_*.yml'
          relabel_configs:
            - target_label: instance
              replacement: {{ otelcol_instance_name | default(inventory_hostname_short) }}

{%     endif %}
{%     if prometheus_ipmi_exporter %}
        - job_name: 'ipmi_exporter'
          scrape_interval: 1m
          scrape_timeout: 30s
          metrics_path: /ipmi
          scheme: http
          file_sd_configs:
            - files:
                - '{{ _otelcol_config_targets_path }}/ipmi_exporter_*.yml'
          relabel_configs:
            - source_labels: [__address__]
              target_label: __param_target
            - source_labels: [__module]
              target_label: __param_module
            - target_label: __address__
              replacement: localhost:9290

{%     endif %}
{%     if prometheus_modbus_exporter %}
        - job_name: modbus_exporter
          metrics_path: '/modbus'
          file_sd_configs:
            - files:
              - '{{ _otelcol_config_targets_path }}/modbus_exporter_*.yml'
          scrape_interval: 10s
          scrape_timeout: 5s
          relabel_configs:
            - source_labels: [__address__]
              target_label: __param_target
            - source_labels: [__param_target]
              target_label: instance
            - source_labels: [__module]
              target_label: __param_module
            - source_labels: [__sub_target]
              target_label: __param_sub_target
            - target_label: __address__
              replacement: localhost:9602

{%     endif %}
{%   endif %}
{% endif %}
processors:
  batch:

  memory_limiter:
    check_interval: {{ otelcol_memory_limiter_check_interval }}
    limit_percentage: {{ otelcol_memory_limiter_limit_percentage }}
    spike_limit_percentage: {{ otelcol_memory_limiter_spike_limit_percentage }}
{% if otelcol_custom_processor is defined %}
{{ otelcol_custom_processor | indent(2,true) }}
{% endif %}
{% if _otelcol_host_telemetry or otelcol_custom_pipeline is defined %}
  resourcedetection/host:
    detectors: [env,system]
    timeout: 2s
    override: false
    system:
      resource_attributes:
        host.arch:
          enabled: true
        host.id:
          enabled: true
        host.name:
          enabled: true
        os.type:
          enabled: true
      hostname_sources: ["os"]

{% endif %}
{% if _otelcol_external_telemetry %}
  resourcedetection/external:
    detectors: [env]
    timeout: 2s
    override: false

{% endif %}
{% if _otelcol_host_telemetry %}
  transform/host:
    metric_statements:
      - context: datapoint
        statements:
          - set(attributes["deployment_environment"], resource.attributes["deployment.environment"])
          - set(attributes["service_namespace"], resource.attributes["service.namespace"])
          - set(attributes["service_name"], "{{ service.name | default('app') }}")
          - set(attributes["service_owner"], resource.attributes["service.owner"])
          - set(attributes["service_team"], resource.attributes["service.team"])
          - set(attributes["host_arch"], resource.attributes["host.arch"])
          - set(attributes["host_name"], resource.attributes["host.name"])
          - set(attributes["os_type"], resource.attributes["os.type"])

{% endif %}
{% if _otelcol_external_telemetry %}
  transform/external:
    metric_statements:
      - context: datapoint
        statements:
          - set(attributes["deployment_environment"], resource.attributes["deployment.environment"])
          - set(attributes["service_namespace"], resource.attributes["service.namespace"])

{% endif %}
exporters:
{% if otelcol_custom_exporter is defined %}
{{ otelcol_custom_exporter | indent(2,true) }}
{% endif %}
{% if _otelcol_metrics %}
  otlp/metrics:
    endpoint: https://{{ otelcol_metrics_gateway }}:443
    auth:
      authenticator: oauth2client/client

{% endif %}
{% if _otelcol_logs %}
  otlp/logs:
    endpoint: https://{{ otelcol_logs_gateway }}:443
    auth:
      authenticator: oauth2client/client
{% endif %}
{% if otelcol_debug %}
  debug:
    verbosity: {{ otelcol_debug_verbosity }}

{% endif %}
service:
  extensions:
{% if _otelcol_metrics or _otelcol_logs%}
    - oauth2client/client
{% endif %}
  pipelines:
{% if otelcol_custom_pipeline  is defined %}
{{ otelcol_custom_pipeline | indent(4,true) }}
{% endif %}
{% if _otelcol_host_telemetry and _otelcol_host_logs %}
{%   if otelcol_receiver_journald %}
    logs/host:
      receivers:
        - journald/host
      processors:
        - memory_limiter
        - batch
        - resourcedetection/host
      exporters: [otlp/logs{% if otelcol_debug %},debug{% endif %}]
{%   elif otelcol_receiver_windows_events %}
    logs/host:
      receivers:
{%     for windows_eventlog in otelcol_receiver_windows_eventlogs %}
        - windowseventlog/{{ windows_eventlog }}
{%     endfor %}
      processors:
        - memory_limiter
        - batch
        - resourcedetection/host
      exporters: [otlp/logs{% if otelcol_debug %},debug{% endif %}]
{%   endif %}
{% endif %}
{% if _otelcol_external_telemetry and _otelcol_external_logs %}
    logs/external:
      receivers: []
      processors:
        - memory_limiter
        - batch
        - resourcedetection/external
      exporters: [otlp/logs{% if otelcol_debug %},debug{% endif %}]
{% endif %}
{% if _otelcol_host_telemetry and _otelcol_host_metrics %}
    metrics/host:
      receivers: [prometheus/host]
      processors:
        - memory_limiter
        - batch
        - resourcedetection/host
        - transform/host
      exporters: [otlp/metrics{% if otelcol_debug %},debug{% endif %}]
{% endif %}
{% if _otelcol_external_telemetry and _otelcol_external_metrics %}
    metrics/external:
      receivers: [prometheus/external]
      processors:
        - memory_limiter
        - batch
        - resourcedetection/external
        - transform/external
      exporters: [otlp/metrics{% if otelcol_debug %},debug{% endif %}]
{% endif %}
